OpenTTD AI API: AIEventVehicleCrashed Class Reference

OpenTTD AI API 15.0-beta2

Public Types | Public Member Functions | Static Public Member Functions
AIEventVehicleCrashed Class Reference

Event Vehicle Crash, indicating a vehicle of yours is crashed. More...

`#include <script_event_types.hpp>`

Inheritance diagram for AIEventVehicleCrashed:

## Public Types
enum | CrashReason { CRASH_TRAIN , CRASH_RV_LEVEL_CROSSING , CRASH_RV_UFO , CRASH_PLANE_LANDING , CRASH_AIRCRAFT_NO_AIRPORT , CRASH_FLOODED }
| The reasons for vehicle crashes. More...
Public Types inherited from AIEvent
enum | AIEventType { ET_INVALID , ET_TEST , ET_SUBSIDY_OFFER , ET_SUBSIDY_OFFER_EXPIRED , ET_SUBSIDY_AWARDED , ET_SUBSIDY_EXPIRED , ET_ENGINE_PREVIEW , ET_COMPANY_NEW , ET_COMPANY_IN_TROUBLE , ET_COMPANY_ASK_MERGER , ET_COMPANY_MERGER , ET_COMPANY_BANKRUPT , ET_VEHICLE_CRASHED , ET_VEHICLE_LOST , ET_VEHICLE_WAITING_IN_DEPOT , ET_VEHICLE_UNPROFITABLE , ET_INDUSTRY_OPEN , ET_INDUSTRY_CLOSE , ET_ENGINE_AVAILABLE , ET_STATION_FIRST_VEHICLE , ET_DISASTER_ZEPPELINER_CRASHED , ET_DISASTER_ZEPPELINER_CLEARED , ET_TOWN_FOUNDED , ET_AIRCRAFT_DEST_TOO_FAR , ET_ADMIN_PORT , ET_WINDOW_WIDGET_CLICK , ET_GOAL_QUESTION_ANSWER , ET_EXCLUSIVE_TRANSPORT_RIGHTS , ET_ROAD_RECONSTRUCTION , ET_VEHICLE_AUTOREPLACED , ET_STORYPAGE_BUTTON_CLICK , ET_STORYPAGE_TILE_SELECT , ET_STORYPAGE_VEHICLE_SELECT , ET_COMPANY_RENAMED , ET_PRESIDENT_RENAMED }
| The type of event. More...

## Public Member Functions
VehicleID | GetVehicleID ()
| Get the VehicleID of the crashed vehicle.
TileIndex | GetCrashSite ()
| Find the tile the vehicle crashed.
CrashReason | GetCrashReason ()
| Get the reason for crashing.
int | GetVictims ()
| Get the number of victims.
AICompany::CompanyID | GetVehicleOwner ()
| Get the CompanyID of the company owning the vehicle.
Public Member Functions inherited from AIEvent
| AIEvent (AIEvent::AIEventType type)
| Constructor of AIEvent, to get the type of event.
AIEventType | GetEventType ()
| Get the event-type.

## Static Public Member Functions
static AIEventVehicleCrashed * | Convert (AIEvent *instance)
| Convert an AIEvent to the real instance.

## Detailed Description

Event Vehicle Crash, indicating a vehicle of yours is crashed.

It contains the crash site, the crashed vehicle and the reason for the crash.

## Member Enumeration Documentation

## ◆ CrashReason

enum AIEventVehicleCrashed::CrashReason

The reasons for vehicle crashes.

Enumerator
CRASH_TRAIN | Two trains collided.
CRASH_RV_LEVEL_CROSSING | Road vehicle got under a train.
CRASH_RV_UFO | Road vehicle got under a landing ufo.
CRASH_PLANE_LANDING | Plane crashed on landing.
CRASH_AIRCRAFT_NO_AIRPORT | Aircraft crashed after it found not a single airport for landing.
CRASH_FLOODED | Vehicle was flooded.

## Member Function Documentation

## ◆ Convert()

static AIEventVehicleCrashed * AIEventVehicleCrashed::Convert | ( | AIEvent * | instance | ) |
| inlinestatic

Convert an AIEvent to the real instance.

Parameters

  instance | The instance to convert.

Returns
  The converted instance.

## ◆ GetCrashReason()

CrashReason AIEventVehicleCrashed::GetCrashReason | ( |  | ) |
| inline

Get the reason for crashing.

Returns
  The reason for crashing

## ◆ GetCrashSite()

TileIndex AIEventVehicleCrashed::GetCrashSite | ( |  | ) |
| inline

Find the tile the vehicle crashed.

Returns
  The crash site.

## ◆ GetVehicleID()

VehicleID AIEventVehicleCrashed::GetVehicleID | ( |  | ) |
| inline

Get the VehicleID of the crashed vehicle.

Returns
  The crashed vehicle.

## ◆ GetVehicleOwner()

AICompany::CompanyID AIEventVehicleCrashed::GetVehicleOwner | ( |  | ) |
| inline

Get the CompanyID of the company owning the vehicle.

Returns
  The company owning the vehicle

## ◆ GetVictims()

int AIEventVehicleCrashed::GetVictims | ( |  | ) |
| inline

Get the number of victims.

Returns
  The number of victims